# incendium-stubs

<!--- Badges --->
[![Downloads](https://pepy.tech/badge/incendium-stubs)](https://pepy.tech/project/incendium-stubs)
[![pre-commit.ci status](https://results.pre-commit.ci/badge/github/ignition-devs/incendium-stubs/main.svg)](https://results.pre-commit.ci/latest/github/ignition-devs/incendium-stubs/main)
[![Join us on GitHub discussions](https://img.shields.io/badge/github-discussions-informational)](https://github.com/ignition-devs/discussions/discussions)

This package contains a collection of [stubs](https://www.python.org/dev/peps/pep-484/) for [`incendium`](https://github.com/ignition-devs/incendium). These files were generated using `mypy`'s [`stubgen`](https://coatl-mypy.readthedocs.io/en/v0.971/stubgen.html).

## Installation and usage

To use `incendium-stubs`, you may install it with `pip`. It requires Python 3.7 through 3.12.

```sh
python -m pip install incendium-stubs
```

To run `mypy` against your code, execute the following command passing the source directory (typically `src`) or a single file:

```sh
mypy src
```

Or

```sh
mypy code.py
```

## Contributing

See [CONTRIBUTING.md](https://github.com/ignition-devs/incendium/blob/HEAD/CONTRIBUTING.md#contributing-to-incendium).

## Discussions

Feel free to post your questions and/or ideas at [Discussions](https://github.com/ignition-devs/discussions/discussions).

## Contributors

Thanks to everyone who has contributed to this project.

Up-to-date list of contributors can be found [here](https://github.com/ignition-devs/incendium-stubs/graphs/contributors).

## License

See the [LICENSE](./LICENSE).

## Code of conduct

See [CODE_OF_CONDUCT.md](https://github.com/ignition-devs/incendium/blob/HEAD/CODE_OF_CONDUCT.md).
